package com.cardsrus.clients;

import com.cardsrus.cardshop.CardShopRemote;
import com.cardsrus.domain.GreetingCard;

import javax.naming.InitialContext;
import javax.naming.Context;
import javax.naming.NamingException;

import javax.rmi.PortableRemoteObject;

public class Client
{
    public static void main(String [] args)
    {
        try
	{
            Context jndiContext = getInitialContext();
            Object ref = jndiContext.lookup("CardShopBean/remote");
            CardShopRemote dao = (CardShopRemote)ref;

            GreetingCard oldGreetingCard = dao.findGreetingCard(1);
            if (oldGreetingCard != null)
            {
				dao.mergeGreetingCard(oldGreetingCard);
				dao.removeGreetingCard(oldGreetingCard);
				dao.flushGreetingCard();
			}

            GreetingCard greetingCard_1 = new GreetingCard();
            greetingCard_1.setId(1);
            greetingCard_1.setGreeting("Early Easter Greetings from Terry Dactyll");
            greetingCard_1.setColour(1);

            dao.createGreetingCard(greetingCard_1);

            GreetingCard greetingCard_2 = dao.findGreetingCard(1);
            System.out.println("Greeting card name: " + greetingCard_2.getGreeting());
            System.out.println("Greeting card colour: " + greetingCard_2.getColour());
        }
        catch (javax.naming.NamingException ne)
        {
	    ne.printStackTrace();
	}
    }

    public static Context getInitialContext()
        throws javax.naming.NamingException
    {
        return new javax.naming.InitialContext();
    }
}