package com.cardsrus.interceptors;

import javax.ejb.*;
import javax.interceptor.*;

public class ExecutionProfiler
{
   @AroundInvoke
   public Object profile(InvocationContext invocation) throws Exception
   {
      long startTimeSnapshot = System.currentTimeMillis();

      System.out.println("Now at the beginning of the interceptor method " +
      invocation.getMethod() + " startTimeSnapshot " + startTimeSnapshot);

      try
      {
         return invocation.proceed();
      }
      finally
      {
         long endTimeSnapshot = System.currentTimeMillis();
         long executionTime = System.currentTimeMillis() - startTimeSnapshot;
         System.out.println("Now at the end of the interceptor method " +
         invocation.getMethod() + " endTimeSnapshot "  + endTimeSnapshot);
         System.out.println("Method " + invocation.getMethod()
                            + " time taken: " + executionTime + " milliseconds");
      }
   }
}
